'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UploadTarball = exports.ReadTarball = undefined;

var _stream = require('stream');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * This stream is used to read tarballs from repository.
 * @param {*} options
 * @return {Stream}
 */
var ReadTarball = function (_PassThrough) {
  _inherits(ReadTarball, _PassThrough);

  /**
   *
   * @param {Object} options
   */
  function ReadTarball(options) {
    _classCallCheck(this, ReadTarball);

    // called when data is not needed anymore
    var _this = _possibleConstructorReturn(this, (ReadTarball.__proto__ || Object.getPrototypeOf(ReadTarball)).call(this, options));

    addAbstractMethods(_this, 'abort');
    return _this;
  }

  return ReadTarball;
}(_stream.PassThrough);

/**
 * This stream is used to upload tarballs to a repository.
 * @param {*} options
 * @return {Stream}
 */


var UploadTarball = function (_PassThrough2) {
  _inherits(UploadTarball, _PassThrough2);

  /**
   *
   * @param {Object} options
   */
  function UploadTarball(options) {
    _classCallCheck(this, UploadTarball);

    // called when user closes connection before upload finishes
    var _this2 = _possibleConstructorReturn(this, (UploadTarball.__proto__ || Object.getPrototypeOf(UploadTarball)).call(this, options));

    addAbstractMethods(_this2, 'abort');

    // called when upload finishes successfully
    addAbstractMethods(_this2, 'done');
    return _this2;
  }

  return UploadTarball;
}(_stream.PassThrough);

/**
 * This function intercepts abstract calls and replays them allowing.
 * us to attach those functions after we are ready to do so
 * @param {*} self
 * @param {*} name
 */


function addAbstractMethods(self, name) {
  self._called_methods = self._called_methods || {};
  self.__defineGetter__(name, function () {
    return function () {
      self._called_methods[name] = true;
    };
  });
  self.__defineSetter__(name, function (fn) {
    delete self[name];
    self[name] = fn;
    if (self._called_methods && self._called_methods[name]) {
      delete self._called_methods[name];
      self[name]();
    }
  });
}

exports.ReadTarball = ReadTarball;
exports.UploadTarball = UploadTarball;